#ifndef _CHANNEL_H_

#define _CHANNEL_H_

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include "client.h"

#define CHANNEL_MAX_LENGTH 64
#define TOPIC_MAX_LENGTH 300
#define CHANNEL_HASH_SIZE 500
#define BAN_LENGTH 63

/* Per Channel modes for users */
#define CHANUSR_OP 	1
#define CHANUSR_VOICE	2

/* Channel Modes */
#define CMODE_TOPIC		1
#define CMODE_INVONLY		2
#define CMODE_MODERATED		4
#define CMODE_MEMONLYSEND	8

/* Small wrapper to client structure for queuing with channels */
struct user_wrap {
	/* Next in list */
	struct user_wrap *next;
	/* Actual client info */
	struct clientinfo *user_info;
	/* Chann mode for user */
	int chan_mode;
};

struct user_ban {
	/* Actual ban string */
	char string[BAN_LENGTH];
	/* Ban Flags */
	/* Speeds up processing */
	int flags;
	/* Pointer to next in list */
	struct user_ban *next;
};

/* Channel structure */
struct channel {
	char topic[TOPIC_MAX_LENGTH];
	char name[CHANNEL_MAX_LENGTH];
	/* Who set the topic */
	char topic_set[NICK_LENGTH];
	/* Time topic set */
	time_t topic_settime;
	/* Start of user list */
	struct user_wrap *users_start;
	/* Channel mode */
	int mode;
	/* Ban list start */
	struct user_ban *bans_start;
};

struct channel *locate_channel(char *);
int prepare_hash();
int add_channel(struct channel *);
int remove_channel(struct channel *);
int rem_client_chan(struct clientinfo *,struct channel *);

#endif
