#include "cmd_notice.h"

/* cmd_privmsg - deals with privmsg system */
int cmd_notice(struct clientinfo *sender,struct parsed_cmd *cmd)
{
	struct clientinfo *recip;
	struct channel *chan;
	struct user_wrap *curr_client;
	char buffer[510];
	
	/* find out if it's a client or a room */
	if(cmd->params[0]==NULL) {
		sprintf(buffer,"%s :Not enough parameters\n",cmd->command);
		send_numeric(sender->fd,sender->nick,461,buffer);
		cmd_free(cmd);
		return EXIT_FAILURE;
	}
	
	/* Attempt to locate client */
	recip = locate_client(cmd->params[0]);

	if(recip==NULL) {
		printf("unable to locate client\n");
		if((chan=locate_channel(cmd->params[0]))==NULL) {
			sprintf(buffer,"%s :No such nick/channel",cmd->params[0]);
			send_numeric(sender->fd,sender->nick,401,buffer);
			cmd_free(cmd);
			return EXIT_SUCCESS;
		} else {
			/* send to a room */
			curr_client=chan->users_start;
			while(1) {
				if(curr_client==NULL) {
					cmd_free(cmd);
					return EXIT_SUCCESS;
				} else {
					if(curr_client->user_info!=sender) {
						sprintf(buffer,"NOTICE %s :%s",chan->name,cmd->text);
						send_to_fd(curr_client->user_info->fd,sender,buffer);
					}
					curr_client=curr_client->next;
				}
			}
		}
	} else {
		/* Send to a client */
		if(privmsg_to_user(sender,recip,cmd->text)==EXIT_SUCCESS) {
			cmd_free(cmd);
			return EXIT_SUCCESS;
		} else {
			cmd_free(cmd);
			return EXIT_FAILURE;
		}
		
	}
}

static int privmsg_to_user(struct clientinfo *sender,
			   struct clientinfo *recip,
			   char *text)
{
	char cmd_buff[500];
	
	/* form end of string */
	if(text==NULL) {
		return EXIT_FAILURE;
	} else {
		sprintf(cmd_buff,"NOTICE %s :%s",recip->nick,text);
	
		/* call procedure to send to client */
	 	return	send_to_fd(recip->fd,sender,cmd_buff);
	}
}

