#include "cmd_part.h"

int cmd_part(struct clientinfo *client,struct parsed_cmd *cmd)
{
	struct channel *chan;
	int i;
	struct user_wrap *curr_client;
	struct user_wrap *prev_client;
	char buffer[150];
	
	if(cmd->params[0]!=NULL) {
		for(i=0;cmd->params[i]!=NULL;i++) {
			/* Check channel exists */
			chan=locate_channel(cmd->params[i]);
			if(chan==NULL) {
				/* Inform user channel doesn't exist */
				sprintf(buffer,"%s :No such channel",cmd->params[i]);
				send_numeric(client->fd,client->nick,403,buffer);
				cmd_free(cmd);
				return EXIT_FAILURE;
			}
				
			/* Check we are a member of this channel */
			curr_client=chan->users_start;
			while(1) {
				if(curr_client!=NULL) {
					if(curr_client->user_info==client) {
						break;
					} else {
						curr_client=curr_client->next;
					}
				} else {
					/* in here, client isn't on that channel */
					sprintf(buffer,"%s :You're not on that channel",chan->name);
					send_numeric(client->fd,client->nick,442,buffer);
					cmd_free(cmd);
					return EXIT_FAILURE;
				}
			}
				
			
			/* Inform channel */
			curr_client=chan->users_start;
			if(cmd->text!=NULL) {
				sprintf(buffer,"PART %s :%s",cmd->params[i],cmd->text);
			} else {
				sprintf(buffer,"PART %s :%s",cmd->params[i],DEFAULT_PART);
			}
			
			send_to_channel(client,chan,buffer);
			
			/* Remove from channel list */
			if(rem_client_chan(client,chan)==EXIT_FAILURE) 
				printf("failed to remove client\n");
			
			/* Do we need to close the channel */
			need_closechan(chan);

			cmd_free(cmd);
				
		}	
			
	} else {
		/* Should inform client about not enough parameters */
		sprintf(buffer,"PART :Not enough paramters");
		send_numeric(client->fd,client->nick,461,buffer);
		cmd_free(cmd);
		return EXIT_FAILURE;
	}
}


/* Checks to see if channel should be closed */
static int need_closechan(struct channel *chan)
{
	if(chan->users_start==NULL) {
		remove_channel(chan);
		free(chan);
	}
}
