#include "cmd_ping.h"

/* Check fd_list for pings */
int check_pings(struct clientinfo *fd_list[],int *highest_fd,struct clientinfo *list_start) 
{
	int i;
	char buffer[100];
	
	for(i=0;i<MAX;i++) {
		if(fd_list[i]!=NULL) {
			if((fd_list[i]->lastrecv)+(2*PING_SECS)<time(NULL) && 
					(fd_list[i]->flags & USR_PINGSENT)==1) {
				ircd_sprintf(buffer,100,"Ping timeout");
				force_quit(fd_list[i],fd_list,highest_fd,buffer,list_start);
			} else {	
				if((fd_list[i]->lastrecv)+PING_SECS<time(NULL) 
						&& !(fd_list[i]->flags & USR_PINGSENT)) {
					/* last data from client more than 90 secs ago */
					/* send a ping */
					fd_list[i]->flags |= USR_PINGSENT;
					send_ping(fd_list[i]);
				}
			}
		}
	}
					
}

/* respond to a ping */
int cmd_ping(struct clientinfo *client,struct parsed_cmd *cmd)
{
	char buffer[200];
	
	if(cmd->text!=NULL) {	
		ircd_sprintf(buffer,200,":%s PONG %s :%s\n",server_name,cmd->text,cmd->params[0]);
	} else {
		if(cmd->params[1]!=NULL) {
			ircd_sprintf(buffer,200,":%s PONG %s %s\n",server_name,cmd->params[1],cmd->params[0]);
		} else {
			return cmd_free(cmd);
		}
	}
	send_raw(client->fd,buffer);
	return cmd_free(cmd);
}


/* send a ping packet */
static int send_ping(struct clientinfo * recip)
{
	char buffer[200];
	ircd_sprintf(buffer,200,"PING %ld :%s\n",time(NULL),server_name);
	printf("buffer is **%s** before a ping send\n");
	send_raw(recip->fd,buffer);
}
