#include "cmd_quit.h"

/* cmd_quit - deals with quit commands */    
int cmd_quit(struct clientinfo *sender,struct parsed_cmd *cmd,
	     struct clientinfo *fd_list[],int *highest_fd,
	     struct clientinfo *start)
{
	int i;
	char buffer[100];
	
	/* Loop and inform room members */
	inform_rooms(sender,cmd->text);
	
	/* Return Error message to client */
	sprintf(buffer,"ERROR :Have fun\n");
	send_raw(sender->fd,buffer);
	
	/* If we are highest, find next highest */
	fd_list[sender->fd]=NULL;
	if(sender->fd==*highest_fd) {
		for(i=sender->fd;i>=0 ;i--) {
			if(fd_list[i]!=NULL) {
				*highest_fd=i;
				i=-1;
			}
		}
		if(i==0) 
			*highest_fd=-1;
	}

	/* Close fd */	
	close(sender->fd);

	/* Remove from tree */
	if(remove_client(sender->nick)==CLIENT_FAILED) {
		remove_from_list(sender,start);
	}

	clients--;	
	cmd_free(cmd);
}


int force_quit(struct clientinfo *client,struct clientinfo *fd_list[],
		int *highest_fd,char *reason,struct clientinfo *start)
{
	int i;
	char buffer[50];
	
	/* Remove client from fd array */
	fd_list[client->fd]=NULL;

	/* Inform room(s) */
	inform_rooms(client,reason);	
	
	sprintf(buffer,"ERROR :%s\n",reason);	
	send_raw(client->fd,buffer);
		
	/* Find next highest */
	if(client->fd==*highest_fd) {
		for(i=client->fd;i>=0;i--) {
			if(fd_list[i]!=NULL) {
				*highest_fd=i;
				i=-1;
			}
		}
		if(i==0)  {
			/* tag it for serve to reset to server fd */
			*highest_fd=-1;
		}
	}
	/* Close socket */
	close(client->fd);

	/* Remove from tree */
	if(remove_client(client->nick)==CLIENT_FAILED) {
		remove_from_list(client,start);
	}

	clients--;
}

/* inform rooms of departure */
/* remove client from channel structs */
/* remove channels from client struct */
static int inform_rooms(struct clientinfo *client,char *reason) 
{
	struct chan_wrap * curr_chan;
	struct chan_wrap * prev_chan;
	struct user_wrap * curr_user;
	struct user_wrap * prev_user=NULL;
	char buffer[100];
	int flag=0;

	curr_chan=client->chan_start;
	if(reason!=NULL) {
		sprintf(buffer,"QUIT :%s",reason);
	} else {
		sprintf(buffer,"QUIT :I just feel like it");
	}
	
			
	/* Loop though channels */
	curr_chan=client->chan_start;
	while(curr_chan!=NULL) {
		/* Loop though users in that channel */
		curr_user=curr_chan->chan_info->users_start;
		while(curr_user!=NULL) {
			flag=0;
			/* If it's us, set a flag, and miss out */
			if(curr_user->user_info->fd!=client->fd) {
				send_to_fd(curr_user->user_info->fd,client,buffer);
			} else {
				flag=1;
			}
			if(flag==1) {
				if(curr_user==curr_chan->chan_info->users_start) {
					/* remove user from start of queue */
					curr_chan->chan_info->users_start=curr_user->next;
					free(curr_user);
					curr_user=curr_chan->chan_info->users_start;
				} else {
					/* remove user anywhere else */
					prev_user->next=curr_user->next;
					free(curr_user);
					curr_user=prev_user->next;
				}
			} else {
				/* Advance list */
				prev_user=curr_user;
				curr_user=curr_user->next;
			}
			
		}
		
		/* Clear memory */
		prev_chan=curr_chan;
		curr_chan=curr_chan->next;
		free(prev_chan);
	}	
	

}
	
/* Remove a user from the temporary list */
static int remove_from_list(struct clientinfo *client,
			    struct clientinfo *list_start)
{
	struct clientinfo *prev_cli=NULL;
	struct clientinfo *curr_cli=NULL;

	curr_cli=list_start;

	if(list_start==curr_cli) {
		list_start=curr_cli->list_next;
		free(curr_cli);
		return EXIT_SUCCESS;
	}

	while(curr_cli!=NULL) {
		if(curr_cli==client) {
			prev_cli->list_next=curr_cli->list_next;
			free(curr_cli);
			return EXIT_SUCCESS;
		}
		prev_cli=curr_cli;
		curr_cli=curr_cli->list_next;
	}

	return EXIT_FAILURE;
}
		
		
