#include "cmd_who.h"

/* cmd_who - deals with WHO requests */
int cmd_who(struct clientinfo *sender,struct parsed_cmd *cmd)
{
	struct channel * chan;
	struct user_wrap * curr_wrap;
	char buffer[BUF_SIZE];
	
	/* check for params */
	if(cmd->params[0]==NULL) {
		cmd_free(cmd);
		return EXIT_FAILURE;
	} 
	if(check_channel(cmd->params[0])) {
		chan=locate_channel(cmd->params[0]);
		
		if(chan==NULL) {
			/* Failed to find channel */
			cmd_free(cmd);
			return EXIT_FAILURE;
		}
		
		curr_wrap=chan->users_start;
		while(curr_wrap!=NULL) {
			sprintf(buffer,"%s %s %s %s %s %c :%d %s",chan->name,
							      	curr_wrap->user_info->user,
							      	curr_wrap->user_info->host,
							      	"Unimplemented",
							      	curr_wrap->user_info->nick,
								'H',
							      	0,
							      	curr_wrap->user_info->real_name);
			
			send_numeric(sender->fd,sender->nick,352,buffer);
			curr_wrap=curr_wrap->next;
		}
		sprintf(buffer,"%s :End of /WHO list.",chan->name);
		send_numeric(sender->fd,sender->nick,315,buffer);
		cmd_free(cmd);
		return EXIT_SUCCESS;
	}
	
}

