#include "cmd_whois.h"

/* cmd_privmsg - deals with privmsg system */
int cmd_whois(struct clientinfo *sender,struct parsed_cmd *cmd)
{
	struct clientinfo *user_about=NULL;
	char buffer[BUF_SIZE];
	
	if(cmd->params[0]==NULL) {
		/* Send error reply */
		send_numeric(sender->fd,sender->nick,431,":No nickname given");
		cmd_free(cmd);
		return EXIT_FAILURE;
	}
	
	user_about=locate_client(cmd->params[0]);
		
	/* Return to sender, with correct reply */
	if(user_about!=NULL) {
		/* General Info */
		sprintf(buffer,"%s %s %s :%s",user_about->nick,
					      user_about->user,
					      user_about->host,
					      user_about->real_name);
		send_numeric(sender->fd,sender->nick,311,buffer);
		/* Server info */
		sprintf(buffer,"%s %s",user_about->nick,server_name);
		send_numeric(sender->fd,sender->nick,312,buffer);
		/* Inform if irc op */
		if( (user_about->mode & MODE_IRCOP) ) {
			sprintf(buffer,"%s :Is an IRC Operator",sender->nick);
			send_numeric(sender->fd,sender->nick,313,buffer);
		}
		/* Idle time */
		sprintf(buffer,"%s %d :seconds idle",user_about->nick,
					 	     time(NULL)-(user_about->lastrecv));
		send_numeric(sender->fd,sender->nick,317,buffer);
		/* Add channel loop here */

		/* Inform end of whois */
		sprintf(buffer,"%s :End of WHOIS List",user_about->nick);
		send_numeric(sender->fd,sender->nick,319,buffer);
		

	} else {
		/* Send error reply */
		sprintf(buffer,"%s :No such nick/channel",cmd->params[0]);
		send_numeric(sender->fd,sender->nick,401,buffer);	
	}
	cmd_free(cmd);
	return EXIT_SUCCESS;
}

